<?php

namespace App\Http\Requests\CustomerOpeningStock;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\Exceptions\HttpResponseException;
use Illuminate\Validation\Rule;

class CustomerOpeningStockStoreRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, \Illuminate\Contracts\Validation\ValidationRule|array<mixed>|string>
     */
    public function rules(): array
    {


        return [
            'customer_id' => [
                'required',
                Rule::unique('customer_openings', 'client_id')->where(function ($query) {
                    return $query->where('warehouse_id', request()->warehouse_id);
                }),
            ],

        ];
    }

    public function failedValidation($validator)
    {
        $errors = $validator->errors();
        throw new HttpResponseException(response()->json(['errors' => $errors], 422));
    }
}
